# BENOIT-LAVER analysis for LEFT-RIGHT scale

use countries_left_right.dta, clear

gen LRcrm =  . 
label var LRcrm "Corrected LR mean, manual"
gen LRcrse = . 
label var LRcrse "Corrected LR s.e., manual"
gen LRmean = .
label var LRmean "Original LR mean, manual"
gen LRse = . 
label var LRse "Original LR s.e., manual"
gen b0 = .
gen b1 = .
gen b0se = .
gen b1se = .
gen N = .

levels country, local(plist)
foreach p of local plist {
	quietly levels partynam if country==`p', local(clist) 
    	foreach c of local clist {
	quietly ci score13 if country==`p' & partynam==`c' & score99!=. 
	quietly replace LRmean = r(mean) if country==`p' & partynam==`c'
	local n = r(N)
	quietly replace LRse = r(se) if country==`p' & partynam==`c'
	di "partynam `c'"
	reg score13 score99 if country==`p' & partynam==`c', robust
	quietly replace score99 = 10.5 if country==`p' & partynam==`c'
	quietly capture drop yhat yhatse
      quietly predict yhat
      quietly predict yhatse, stdp
      quietly replace LRcrm = yhat if country==`p' & partynam==`c'
      quietly replace LRcrse = yhatse if country==`p' & partynam==`c'
	matrix b = e(b)
	matrix vc = e(V)
      local sigma = e(rmse)
	local n = e(N)
      local b1 = b[1,1]
	local b0 = b[1,2]
	replace b0 = `b0' if country==`p' & partynam==`c'
	replace b1 = `b1' if country==`p' & partynam==`c'
	replace b1se =  sqrt(vc[1,1]) if country==`p' & partynam==`c'
	replace b0se =  sqrt(vc[2,2]) if country==`p' & partynam==`c'
	replace N = `n' if country==`p' & partynam==`c'
		}
    	}

gen LRdev = LRmean - LRcrm
gen LRdevse = sqrt(LRse^2 + LRcrse^2)
gen testt = LRdev/LRdevse

